#ifndef FONTFILE_H
#define FONTFILE_H

// magic value for font-files (FNT2)
//
#define  FONT_MAGIC   0x32544e46

/**
 * In-Memory bitmap font structure.
 *
 * \warning
 *   Any changes to this structure must be reflected
 *   in the printScratch() function. The qtFont editor
 *   should be changed, too.
 */
typedef struct Font {
  short   firstChar;      //  +0  ascii offset for first char
  short   numChars;       //  +2  number of characters in font
  short   maxWidth;       //  +4  maximum character width
  short   height;         //  +6  height of font characters

  short   pageSize;       //  +8  size of a font page
  short   numPages;       // +10  number of font pages

  unsigned  short  offsets[];    // +12
} Font;

#endif
